using System.IO;
using Microsoft.VisualStudio.Data.Framework.AdoDotNet;

namespace VfpClient.Design {
    internal class DataSourceInformation : AdoDotNetSourceInformation {
        protected override object RetrieveValue(string propertyName) {
            VfpClientTracing.Tracer.TraceVerbose(string.Format("DataSourceInformation.RetrieveValue propertyName={0}", propertyName));

            switch (propertyName) { 
                case "DefaultCatalog":
                    var vfpConnection = (VfpConnection)Connection;

                    if (vfpConnection.IsDbc) {
                        return Path.GetFileNameWithoutExtension(vfpConnection.Database);
                    }

                    break;
            }
            
            return base.RetrieveValue(propertyName);
        }
    }
}